package npb.nasft;

import integratedtoolkit.types.annotations.Method;
import integratedtoolkit.types.annotations.Parameter;
import integratedtoolkit.types.annotations.Parameter.*;

public interface NASFTItf {

    @Method(declaringClass = "npb.nasft.NASFTImpl")
    void FFT_layout0(
        @Parameter
        int numberProcs,
        @Parameter
        char problemSize,
        @Parameter
        int maxdim,
        @Parameter
        int[] dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u0,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter(direction = Direction.INOUT)
        double[] u,
        @Parameter(direction = Direction.INOUT)
        double[] twiddle,
        @Parameter
        int xstart2,
        @Parameter
        int ystart1,
        @Parameter
        int ystart2,
        @Parameter
        int zstart1,
        @Parameter
        int zstart2
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl")
    double[] inverseFFT_layout0(
        @Parameter
        int nx,
        @Parameter
        int ny,
        @Parameter
        int nz,
        @Parameter
        int ntotal_f,
        @Parameter
        int maxdim,
        @Parameter
        int[] dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u0,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter(direction = Direction.INOUT)
        double[] u2,
        @Parameter
        double[] twiddle,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter(direction = Direction.INOUT)
        double[] u,
        @Parameter
        int xstart0,
        @Parameter
        int xend0,
        @Parameter
        int ystart0,
        @Parameter
        int yend0,
        @Parameter
        int zstart0,
        @Parameter
        int zend0
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    double[] FFT_layout1_init(
        @Parameter
        int numberProcs,
        @Parameter
        char problemSize,
        @Parameter
        int maxdim,
        @Parameter
        int d1,
        @Parameter
        int d2,
        @Parameter
        int[] dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u0,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter(direction = Direction.INOUT)
        double[] u,
        @Parameter(direction = Direction.INOUT)
        double[] twiddle,
        @Parameter
        int xstart2,
        @Parameter
        int ystart1,
        @Parameter
        int ystart2,
        @Parameter
        int zstart1,
        @Parameter
        int zstart2
    );


    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    double[] inverseFFT_layout1_init(
        @Parameter
        int maxdim,
        @Parameter
        int d1,
        @Parameter
        int d2,
        @Parameter
        int[] dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u0,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter(direction = Direction.INOUT)
        double[] u2,
        @Parameter
        double[] twiddle,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter
        double[] u
    );


    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    void FFT_layout1_end(
        @Parameter
        int np2,
        @Parameter
        int d1,
        @Parameter
        int d2,
        @Parameter
        int[] dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u0,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter
        double[] scratch,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter
        double[] u
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    double[] inverseFFT_layout1_end(
        @Parameter
        int nx,
        @Parameter
        int ny,
        @Parameter
        int nz,
        @Parameter
        int np2,
        @Parameter
        int ntotal_f,
        @Parameter
        int d1,
        @Parameter
        int d2,
        @Parameter
        int[]dims1,
        @Parameter(direction = Direction.INOUT)
        double[] u1,
        @Parameter(direction = Direction.INOUT)
        double[] u2,
        @Parameter
        double[] scratch,
        @Parameter
        int fftblock,
        @Parameter
        int fftblockpad,
        @Parameter
        double[] u,
        @Parameter
        int xstart0,
        @Parameter
        int xend0,
        @Parameter
        int ystart0,
        @Parameter
        int yend0,
        @Parameter
        int zstart0,
        @Parameter
        int zend
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    void getComplexArray(
    	@Parameter
        int i,
        @Parameter
        double[] xin,
        @Parameter
        double[] xin1,
        @Parameter
        double[] xin2,
        @Parameter
        double[] xin3,
        @Parameter(direction = Direction.INOUT)
        double[] temp
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    void setComplexArray(
	@Parameter
        int i,
        @Parameter
        double[] xin,
        @Parameter(direction = Direction.INOUT)
        double[] xout,
        @Parameter(direction = Direction.INOUT)
        double[] xout1,
        @Parameter(direction = Direction.INOUT)
        double[] xout2,
        @Parameter(direction = Direction.INOUT)
        double[] xout3
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl")
    void reduceComplex(
        @Parameter(direction = Direction.INOUT)
        double[] chk1,
        @Parameter
        double[] chk2
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    double[] allocComplexArray(
		@Parameter
        int size
    );

    @Method(declaringClass = "npb.nasft.NASFTImpl", isInit = true)
    int synchronize(
		@Parameter
        double[] d
    );

}
